#!/usr/bin/python
# coding=UTF-8
import urllib
import json
import sys
import time
import pynotify

# OPTIONS START
timeout = 30
board = "lor"
thread = "16218"
#OPTIONS END

if not pynotify.init("Dobrochan notificator"):
    print "There was a problem initializing the pynotify module. Maybe it's not installed?"
    exit()

err = 1
while err:
    try:      
        info = urllib.urlopen("http://dobrochan.ru/api/thread/info/%s/%s.json"%(board,thread))
        messages = urllib.urlopen("http://dobrochan.ru/%s/res/%s.json"%(board,thread))
        infoDump = info.read()
        messDump = messages.read()
        infoObj = json.loads(infoDump)
        messObj = json.loads(messDump)
        err = 0
    except:
        print u"Не могу получить данные... Повтор"
        time.sleep(timeout)
        err = 1
print u"В треде >>%s/%s \"%s\" найдено: сообщений - %s, файлов - %s. Последнее изменение произведено в %s"%(
    board,
    thread,
    infoObj['boards'][board]['threads'][0]['title'],
    infoObj['boards'][board]['threads'][0]['posts_count'],
    infoObj['boards'][board]['threads'][0]['files_count'],
    infoObj['boards'][board]['threads'][0]['last_modified']
)
lastId = messObj['boards'][board]['threads'][0]['posts'].pop()['display_id']
posts = []
while 1:
    try:
        messages = urllib.urlopen("http://dobrochan.ru/api/thread/new/%s/%s.json?last_post=%s"%(board,thread,lastId))
        messDump = messages.read()
        messObj = json.loads(messDump)
    except:
        print u"Ошибка подключения.. Повтор"
        time.sleep(timeout)
        continue
    if 'posts' in messObj['boards'][board]['threads'][0]:
        posts = messObj['boards'][board]['threads'][0]['posts']
    else:
        posts = []
    for post in posts:
        lastId = post['display_id']
        print post['message']
        n = pynotify.Notification(
            u"%s: Новое сообщение %s:" % (infoObj['boards'][board]['threads'][0]['title'], post['date']),
            post['message'])
        n.set_urgency(pynotify.URGENCY_NORMAL)
        n.show()
    time.sleep(timeout)